Bug 28196 - FlowAnalysis issue with out parameter and finally and delegate containing a return
Summary: FlowAnalysis issue with out parameter and finally and delegate containing a r...
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: 3.12.0
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2015-03-19 10:43 UTC by Timotheus Pokorra
Modified: 2015-03-27 02:38 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
this file does not compile with Mono (782 bytes, text/x-csharp)
2015-03-19 10:43 UTC, Timotheus Pokorra
Details

Description Timotheus Pokorra 2015-03-19 10:43:13 UTC
Created attachment 10412 [details]
this file does not compile with Mono

I have attached a file that compiles fine with the Microsoft compiler, and also with Mono 3.2.3, but not with the latest Mono 3.12.1 mcs.

mcs TestDelegateFinallyOut.cs 
shows:

TestDelegateFinallyOut.cs(11,48): error CS0177: The out parameter `test' must be assigned to before control leaves the current method
Compilation failed: 1 error(s), 0 warnings

It compiles fine, if you drop the return inside the delegate, or if you drop the finally clause.

The error message originates here:
https://github.com/mono/mono/blob/master/mcs/mcs/statement.cs#L3712
 fc.Report.Error (177, p.Location,
   "The out parameter `{0}' must be assigned to before control leaves the current method",
   p.Parameter.Name);

This is how far I could debug it...
Comment 1 Marek Safar 2015-03-27 02:38:15 UTC
Fixed in master/mono 4.0

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.


Create a new report for Bug 28196 on Developer Community or GitHub if you have new information to add and do not yet see a matching report.

  • Export the original title and description: Developer Community HTML or GitHub Markdown
  • Copy the title and description into the new report. Adjust them to be up-to-date if needed.
  • Add your new information.

In special cases on GitHub you might also want the comments: GitHub Markdown with public comments


Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Related Links: